=== OpenSceneGraph/examples/osgQtWidgets/CMakeLists.txt ===
SET(TARGET_SRC
    osgQtWidgets.cpp
)

IF(CMAKE_COMPILER_IS_GNUCXX)
    # Remove -pedantic flag as it barfs on Qt headers
   STRING(REGEX REPLACE "-pedantic" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ENDIF()

SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTOPENGL_LIBRARY} ${QT_QTWEBKIT_LIBRARY})
INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})

SET(TARGET_ADDED_LIBRARIES osgWidget osgQt)

#### end var setup  ###
SETUP_EXAMPLE(osgQtWidgets)
