=== OpenSceneGraph/examples/osgqfont/CMakeLists.txt ===
#this file is automatically generated 

INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} )
ADD_DEFINITIONS(-DUSE_QT4)

SET(TARGET_SRC osgqfont.cpp )
SET(TARGET_ADDED_LIBRARIES osgQt osgText)
SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY_RELEASE} ${QT_QTGUI_LIBRARY_RELEASE} ${QT_QTOPENGL_LIBRARY_RELEASE} )

#### end var setup  ###
SETUP_EXAMPLE(osgqfont)
