=== OpenSceneGraph/examples/osgviewerQt/CMakeLists.txt ===
SET( TARGET_SRC
    osgviewerQt.cpp
)

IF( QT4_FOUND )
    SET(TARGET_EXTERNAL_LIBRARIES ${QT_QTCORE_LIBRARY_RELEASE} ${QT_QTGUI_LIBRARY_RELEASE} ${QT_QTOPENGL_LIBRARY_RELEASE} )
    ADD_DEFINITIONS(-DUSE_QT4)
ELSE( QT4_FOUND )
    SET(TARGET_EXTERNAL_LIBRARIES ${QT_LIBRARIES} )
ENDIF( QT4_FOUND )

INCLUDE_DIRECTORIES( ${QT_INCLUDE_DIR} )

SET(TARGET_ADDED_LIBRARIES osgWidget osgQt)

SETUP_EXAMPLE( osgviewerQt )
