=== debian/changelog ===
openscenegraph (3.0.1-4) unstable; urgency=low

  [ Alberto Luaces ]
  * Upgraded standards version to 3.9.3.
  * Append options to LDFLAGS instead of replacing its value.
  * Use of hardening flags for building.
  * Added a manpage for the osgviewerWX executable.
  * Changes in the build prefix in order to fix the pkg-config files
    (Closes: #690878).
  * Removal of unused LINKER_FLAGS variable in debian/rules.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Thu, 22 Nov 2012 22:07:57 +0000

openscenegraph (3.0.1-3) unstable; urgency=low

  * Depend on libpng-dev instead of libpng12-dev for libpng15-transition
    (Closes: #662455)
  * Reformat dependencies in debian/control to show one per line, I think that
    subsequent changes will be much more clear from now on

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 14 Mar 2012 11:18:59 +0000

openscenegraph (3.0.1-2) unstable; urgency=low

  [ Alberto Luaces ]
  * Fixed ffmpeg FTBFS with 0.8 version (Closes: #654233).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 08 Jan 2012 19:38:17 +0000

openscenegraph (3.0.1-1) unstable; urgency=low

  * New upstream fixes release.
  * Fixed ffmpeg FTBFS (Closes: #640339).

 -- Loic Dachary (OuoU) <loic@debian.org>  Thu, 08 Sep 2011 16:06:16 +0200
